## x42-plugins 20131021

=== Makefile ===
--- 
+++ 
@@ -1,7 +1,7 @@
 #!/usr/bin/make
 
 VERSION ?=$(shell date +%Y%m%d)
-SUBDIRS = balance.lv2 convoLV2 nodelay.lv2 xfade.lv2 midifilter.lv2
+SUBDIRS = balance.lv2 convoLV2 nodelay.lv2 xfade.lv2 midifilter.lv2 meters.lv2
 
 all clean install uninstall: submodule_check $(SUBDIRS)
