## x42-plugins 20131119

=== Makefile ===
--- 
+++ 
@@ -1,12 +1,13 @@
 #!/usr/bin/make
 
 VERSION ?=$(shell date +%Y%m%d)
-SUBDIRS = balance.lv2 convoLV2 nodelay.lv2 xfade.lv2 midifilter.lv2 meters.lv2
+SUBDIRS = balance.lv2 convoLV2 nodelay.lv2 xfade.lv2 \
+          midifilter.lv2 meters.lv2 sisco.lv2
 
 all clean install uninstall: submodule_check $(SUBDIRS)
 
 $(SUBDIRS)::
-	$(MAKE) -C $@ $(MAKECMDGOALS)
+	$(MAKE) -C $@ $(MAKECMDGOALS) RW=../robtk/
 
 ###############################################################################
