=== debian/changelog ===
x42-plugins (20131119-3) unstable; urgency=low

  * Remove sse optimalization from sisco properly (Closes: #730421).

 -- Jaromír Mikeš <mira.mikes@seznam.cz>  Tue, 26 Nov 2013 17:18:04 +0100

x42-plugins (20131119-2) unstable; urgency=low

  * Remove sse optimalization also from sisco (Closes: #730308).

 -- Jaromír Mikeš <mira.mikes@seznam.cz>  Sun, 24 Nov 2013 10:19:36 +0100

x42-plugins (20131119-1) unstable; urgency=low

  * Imported Upstream version 20131119.
  * Removed spelling patch - applied upstream.

 -- Jaromír Mikeš <mira.mikes@seznam.cz>  Thu, 21 Nov 2013 14:10:34 +0100

x42-plugins (20131021-2) unstable; urgency=low

  * Added 01-remove-sse.patch (Closes: #728411).
  * Added 02-fix_spelling.patch.

 -- Jaromír Mikeš <mira.mikes@seznam.cz>  Fri, 01 Nov 2013 09:00:56 +0100

x42-plugins (20131021-1) unstable; urgency=low

  [ Jaromír Mikeš ]
  * New upstream release.  
  * Depedencies tighten.
  * Description updated.
  * Update version.

  [ Alessio Treglia ]
  * Set compression to xz.

 -- Jaromír Mikeš <mira.mikes@seznam.cz>  Wed, 23 Oct 2013 22:00:40 +0200

x42-plugins (20130915-1) unstable; urgency=low

  * Initial release (Closes: #712043)  

 -- Jaromír Mikeš <mira.mikes@seznam.cz>  Sun, 15 Sep 2013 21:38:29 +0200
